;coded by UEZ in 2016-08-05

#AutoIt3Wrapper_Compile_Both=y
#pragma compile(Icon, "c:\Program Files (x86)\AutoIt3\Icons\au3.ico")
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/so /pe /rm
#AutoIt3Wrapper_Run_After=del /f /q "%scriptdir%\%scriptfile%_stripped.au3"

#include <GDIPlus.au3>


Global Const $iW = 1000, $iH = 600, $sTitle = "GDI+ Performance Test / "
Global Const $hGUI = GUICreate($sTitle, $iW, $iH)
GUISetState()

_GDIPlus_Startup()
Global Const $hCanvas = _GDIPlus_GraphicsCreateFromHWND($hGUI)
_GDIPlus_GraphicsSetSmoothingMode($hCanvas, 4)
Global Const $hPen = _GDIPlus_PenCreate(0xFF000000)
_GDIPlus_GraphicsClear($hCanvas)

Global $i, $fX1, $fY1, $fX2, $fY2, $iRounds = 20000

Global $fEnd, $fTimer = TimerInit()

For $i = 1 To $iRounds
	$fX1 = Random() * $iW
	$fX2 = Random() * $iW
	$fY1 = Random() * $iH
	$fY2 = Random() * $iH
	_GDIPlus_PenSetColor($hPen, 0xFF000000 + Int(Random() * 0xFFFFFF))
	_GDIPlus_GraphicsDrawLine($hCanvas, $fX1, $fY1, $fX2, $fY2, $hPen)
Next

$fEnd = TimerDiff($fTimer)

_GDIPlus_PenDispose($hPen)
_GDIPlus_GraphicsDispose($hCanvas)
_GDIPlus_Shutdown()

WinSetTitle($hGUI, "", $sTitle  & "Created " & $iRounds & " lines in " & Round($fEnd, 2) & " ms.")

Do
Until GUIGetMsg() = -3