'coded by UEZ in 2016-08-05
#Include "win\gdiplus.bi"
#include "fbgfx.bi"
#include "windows.bi"

Using FB
Using GDIPLUS

Dim Shared As ULong iW, iH
iW = 1000
iH = 600
Dim As String sTitle = "GDI+ Performance Test / "

ScreenControl FB.SET_DRIVER_NAME, "GDI"
ScreenRes iW, iH, 32
WindowTitle sTitle

Dim evt As EVENT

Dim as HWND hHWND
ScreenControl(FB.GET_WINDOW_HANDLE, Cast(Integer, hHWND))

'_GDIPlus_Startup()
Dim GDIPlusStartupInput As GDIPLUSSTARTUPINPUT 
Dim As ULONG_PTR GDIPlusToken 
GDIPlusStartupInput.GdiplusVersion = 1
If (GdiplusStartup(@GDIPlusToken, @GDIPlusStartupInput, NULL) <> 0) Then 
    Print "FAILED TO INIT GDI+!" 
EndIf 

Dim As Any Ptr hCanvas, hPen

GdipCreateFromHWND(hHWND, @hCanvas) '_GDIPlus_GraphicsCreateFromHWND($hGUI)
GdipSetSmoothingMode(hCanvas, 4) '_GDIPlus_GraphicsSetSmoothingMode($hCanvas, 4)
GdipCreatePen1(&hFF000000, 1, 2, @hPen) '_GDIPlus_PenCreate(0xFF000000)
GdipGraphicsClear(hCanvas, &hFF000000) '_GDIPlus_GraphicsClear($hCanvas)

Dim As Single fX1, fY1, fX2, fY2
Dim As ULong iRounds = 20000, i
Dim As Double fEnd, fTimer

fTimer = Timer 'TimerInit()
For i = 1 To iRounds
	fX1 = Rnd() * iW
	fX2 = Rnd() * iW
	fY1 = Rnd() * iH
	fY2 = Rnd() * iH
	GdipSetPenColor(hPen, &hFF000000 + Int(Rnd() * &hFFFFFF)) '_GDIPlus_PenSetColor($hPen, 0xFF000000 + Int(Random() * 0xFFFFFF))
	GdipDrawLine(hCanvas, hPen, fX1, fY1, fX2, fY2) '_GDIPlus_GraphicsDrawLine($hCanvas, $fX1, $fY1, $fX2, $fY2, $hPen)
Next
fEnd = (Timer - fTimer) * 1000 'TimerDiff($fTimer) -> FB counts in seconds not in ms!

GdipDeletePen(hPen) '_GDIPlus_PenDispose($hPen)
GdipDeleteGraphics(hCanvas) '_GDIPlus_GraphicsDispose($hCanvas)
GdiplusShutdown(GDIPlusToken) '_GDIPlus_Shutdown()

WindowTitle sTitle & "Created " & iRounds & " lines in " & fEnd & " ms."

Do
	'something like GUIGetMsg()
	If (ScreenEvent(@evt)) Then
		Select Case evt.Type 
			Case SC_ESCAPE, EVENT_WINDOW_CLOSE
				Exit Do
		End Select
	EndIf
	Sleep(30)
Loop